SystemOrganization addCategory: #'FileSystem-Smalltalk'!

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:31'!
basename
	^ self name! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:30'!
fileEntriesDo: aBlock
	self hasClassExtensions 
		ifTrue: [ aBlock value: self packageExtension ].
	aBlock value: self packageResources.
	self definedClasses do: aBlock! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:36'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	self definedClasses do: [ :cls|
		cls name = pathSegment 
			ifTrue: [ ^ cls ]].
	pathSegment = #extension
		ifTrue: [ ^ self packageExtension ].
	pathSegment  = #resource
		ifTrue: [ ^ self packageResources ].
	^ absentBlock value! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:14'!
hasClassExtensions
	^ (classExtensionSelectors isEmpty and: [ metaclassExtensionSelectors isEmpty ]) not.! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 21:30'!
isDirectory 
	^ true! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:52'!
isFile
	^ self isDirectory not! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 21:40'!
packageExtension
	^ PackageExtension package: self! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 22:23'!
packageResources
	^ ResourcesEntry on: self name! !

!RPackage methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 23:56'!
resources
	^ FileSystem st / self package name / 'resources'! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:46'!
basename
	^ self name! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 00:29'!
creationTime 
	^ DateAndTime now! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:29'!
fileEntriesDo: aBlock
	aBlock value: self organization.
	aBlock value: self class organization.
	aBlock value: (ClassCommentEntry class: self).
	aBlock value: (ResourcesEntry on: self)! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:39'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	pathSegment = #class
		ifTrue: [ ^ self organization ].
	pathSegment = #instance
		ifTrue: [ ^ self  organization ].
	pathSegment = #'README.md'
		ifTrue: [ ^ ClassCommentEntry class: self  ].
	pathSegment = #resources
		ifTrue: [ ^ ResourcesEntry on: self ].
	^ absentBlock value.! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:46'!
fileSize
	^ 4! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 23:52'!
isDirectory
	^ true! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 00:29'!
modificationTime  
	^ DateAndTime now! !

!Class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 23:55'!
resources
	^ FileSystem st / self package name / self name / 'resources'! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:40'!
basename 
	^ self selector asString, '.st'! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 00:28'!
creationTime 
	"^ self timeStamp"
	^ DateAndTime now! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:37'!
fileEntryCopyFrom: start to: end
	^ self getSource copyFrom: start to: end  ! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:39'!
fileSize
	^ self getSource size! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:31'!
internalSize
	^ self getSource size! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 00:18'!
isDirectory
	^ false! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:39'!
isFile
	^ self isDirectory not! !

!CompiledMethod methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/3/2012 00:27'!
modificationTime
	"^ self timeStamp"
	^ DateAndTime now! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:46'!
basename
	^ self subject isMeta
		ifTrue: [ 'class' ]
		ifFalse: [ 'instance']! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 23:59'!
creationTime 
	^ DateAndTime now! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:29'!
fileEntriesDo: aBlock
	self categories do: [ :name|
		aBlock value: (ProtocolEntry class: self subject protocol: name)]! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:38'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	^ (self listAtCategoryNamed: pathSegment)
		ifNil: absentBlock
		ifNotNil: [
			ProtocolEntry 
				class: self subject
				protocol: pathSegment ]! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:46'!
fileSize
	^ self categories size! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 23:43'!
isDirectory
	^ true! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:31'!
isFile
	^ self isDirectory not! !

!ClassOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 23:59'!
modificationTime  
	^ DateAndTime now! !

!ProtoObject class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:29'!
isFile
	^ self isDirectory not.! !

!RPackageOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:30'!
fileEntriesDo: aBlock
	self packages sorted do: aBlock! !

!RPackageOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:31'!
fileEntryAt: segment ifAbsent: aBlock
	^ packages at: segment asSymbol ifAbsent: aBlock! !

!RPackageOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 21:26'!
isDirectory
	^ true! !

!RPackageOrganizer methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/16/2012 18:18'!
isFile
	^ false! !

MemoryStore subclass: #SmalltalkStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

SmalltalkStore class
	instanceVariableNames: 'currentFileSystem'!

!SmalltalkStore commentStamp: '<historical>' prior: 0!
I am store for the internal smalltalk filesystem!

SmalltalkStore class
	instanceVariableNames: 'currentFileSystem'!

!SmalltalkStore class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 21:18'!
current
	^ self currentFileSystem store! !

!SmalltalkStore class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 21:18'!
currentFileSystem
	^ currentFileSystem ifNil: [
		currentFileSystem := FileSystem store: self new ]! !

!SmalltalkStore class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 21:18'!
reset
	currentFileSystem := nil.! !

!SmalltalkStore methodsFor: 'printing' stamp: 'CamilloBruni 7/2/2012 21:27'!
forReferencePrintOn: aStream
	aStream nextPutAll: 'st:'! !

!SmalltalkStore methodsFor: 'initialization' stamp: 'CamilloBruni 7/2/2012 21:25'!
initialize
	super initialize.
	root := RPackageOrganizer default.! !

!FileSystem class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 21:21'!
smalltalk
	^ SmalltalkStore currentFileSystem! !

!FileSystem class methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 21:21'!
st
	^ self smalltalk! !

Object subclass: #AbstractSmalltalkFileSystemEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:24'!
basename 
	self subclassResponsibility! !

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:26'!
creationTime 
	self flag: #todo. "Extract the creation date"
	^ DateAndTime now! !

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:24'!
fileSize 
	self subclassResponsibility! !

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:23'!
isDirectory 
	self subclassResponsibility! !

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:23'!
isFile
	^ self isDirectory not! !

!AbstractSmalltalkFileSystemEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:27'!
modificationTime 
	self flag: #todo. "Extract the creation date"
	^ DateAndTime now! !

AbstractSmalltalkFileSystemEntry subclass: #ClassCommentEntry
	instanceVariableNames: 'clazz comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!ClassCommentEntry class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 22:14'!
class: aClass
	^ self new
		class: aClass;
		yourself! !

!ClassCommentEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:34'!
basename
	^ 'README.md'! !

!ClassCommentEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:30'!
class: aClass
	clazz := aClass.
	comment := clazz comment.! !

!ClassCommentEntry methodsFor: 'streaming' stamp: 'CamilloBruni 7/16/2012 18:37'!
fileEntryCopyFrom: from to: position
	^ comment copyFrom: from to: position! !

!ClassCommentEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:36'!
fileSize
	^ clazz comment size! !

!ClassCommentEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:30'!
internalSize
	^ comment size! !

!ClassCommentEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 22:15'!
isDirectory 
	^ false! !

AbstractSmalltalkFileSystemEntry subclass: #PackageClassExtension
	instanceVariableNames: 'clazz package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!PackageClassExtension class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/3/2012 00:35'!
package: anRPackage class: aClass
	^ self new
		package: anRPackage;
		class: aClass;
		yourself! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:34'!
basename
	^ clazz name asString! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:35'!
class: aClass
	clazz := aClass! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:54'!
entries
	^ Array streamContents: [ :s|
		self haltOnce.
		(package extensionSelectorsForClass: clazz) isEmpty 
			ifFalse: [ s nextPut: (PackageClassExtensionOrganizer class: clazz package: package) ].
		(package extensionSelectorsForClass: clazz class) isEmpty
			ifFalse: [ s nextPut:  (PackageClassExtensionOrganizer class: clazz class package: package) ]].! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:42'!
fileEntriesDo: aBlock
	self haltOnce.
	self entries do: aBlock! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:40'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	self haltOnce.
	pathSegment = #instance
		ifTrue: [ ^ PackageClassExtensionOrganizer class: clazz package: package ].
		
	pathSegment = #class
		ifTrue: [ ^ PackageClassExtensionOrganizer class: clazz class package: package ].
		
	^ absentBlock value! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:35'!
fileSize
	^ self entries size! !

!PackageClassExtension methodsFor: 'testing' stamp: 'CamilloBruni 7/2/2012 23:39'!
isDirectory
	^ true! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 21:45'!
package
	
	^ package! !

!PackageClassExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 21:45'!
package: anObject
	
	package := anObject! !

AbstractSmalltalkFileSystemEntry subclass: #PackageExtension
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!PackageExtension class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 21:38'!
package: anRPackage
	^ self new
		package: anRPackage;
		yourself! !

!PackageExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:34'!
basename
	^ 'extension'! !

!PackageExtension methodsFor: 'testing' stamp: 'CamilloBruni 7/11/2012 15:42'!
fileEntriesDo: aBlock
	(package extendedClasses collect: #theNonMetaClass) asSet do: [ :cls|
		aBlock value: (PackageClassExtension package: package class: cls )]! !

!PackageExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:40'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	^ PackageClassExtension
		package: package
		class: (package extendedClasses
			detect: [ :cls | cls name = pathSegment ]
			ifNone: [ ^ absentBlock value ])! !

!PackageExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:35'!
fileSize
	self flag: #todo.
	^ 0! !

!PackageExtension methodsFor: 'testing' stamp: 'CamilloBruni 7/2/2012 21:42'!
isDirectory 
	^ true! !

!PackageExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 21:38'!
package
	
	^ package! !

!PackageExtension methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 21:38'!
package: anObject
	
	package := anObject! !

AbstractSmalltalkFileSystemEntry subclass: #ProtocolEntry
	instanceVariableNames: 'clazz protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!ProtocolEntry class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/2/2012 23:48'!
class: aClass protocol: aProtocolName
	^ self new
		class: aClass;
		protocol: aProtocolName;
		yourself! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:34'!
basename
	^ protocol! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 23:49'!
class: aClass
	
	clazz := aClass! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:47'!
fileEntriesDo: aBlock
	self methods do: aBlock! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/16/2012 18:41'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	^ clazz methodDict
		at: (pathSegment copyUpToLast: $.) asSymbol
		ifAbsent: absentBlock! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:35'!
fileSize
	^ self methods! !

!ProtocolEntry methodsFor: 'testing' stamp: 'CamilloBruni 7/2/2012 23:49'!
isDirectory 
	^ true! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:25'!
methods
	^ (clazz methodsInCategory: protocol) collect: [ :selector| clazz methodNamed: selector ]! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 23:47'!
protocol
	
	^ protocol! !

!ProtocolEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 23:47'!
protocol: anObject
	
	protocol := anObject! !

AbstractSmalltalkFileSystemEntry subclass: #ResourcesEntry
	instanceVariableNames: 'fs fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

ResourcesEntry class
	instanceVariableNames: 'cache'!

!ResourcesEntry commentStamp: '<historical>' prior: 0!
I am an abstract!

ResourcesEntry class
	instanceVariableNames: 'cache'!

!ResourcesEntry class methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 22:22'!
cache
	^ cache ifNil: [ 
		cache := WeakIdentityKeyDictionary new ]! !

!ResourcesEntry class methodsFor: 'instance-creation' stamp: 'CamilloBruni 7/2/2012 22:21'!
on: anIdentifier
	^ self cache 
		at: anIdentifier
		ifAbsentPut: [ self new ].! !

!ResourcesEntry class methodsFor: 'instance-creation' stamp: 'CamilloBruni 7/2/2012 22:21'!
reset
	cache := nil! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 23:53'!
at: pathSegment ifPresent: absentBlock
	^ fileSystem ifNotNil: [
		self root at: pathSegment ifPresent: absentBlock ]! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:33'!
basename
	^ 'resources'! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 23:53'!
ensureDirectory: name
	self root ensureDirectory: name! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:32'!
fileEntriesDo: aBlock
	fileSystem ifNil: [ ^ self ].
	self root do: aBlock ! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:39'!
fileEntryAt: pathSegment ifAbsent: absentBlock
	^ fileSystem 
		ifNil: absentBlock
		ifNotNil: [
			self root at: pathSegment ifAbsent: absentBlock ]! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:35'!
fileSize
	fileSystem ifNil: [ ^ 0].
	^ fileSystem root entry size.! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 22:19'!
fileSystem
	^ fileSystem ifNil: [ 
		fileSystem := FileSystem memory ].! !

!ResourcesEntry methodsFor: 'initialize-release' stamp: 'CamilloBruni 7/2/2012 22:17'!
initialize 
	super initialize.! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/2/2012 22:26'!
isDirectory
	^ true! !

!ResourcesEntry methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 23:53'!
root
	^ self fileSystem store root! !

Object subclass: #PackageClassExtensionOrganizer
	instanceVariableNames: 'clazz package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Smalltalk'!

!PackageClassExtensionOrganizer class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/3/2012 00:44'!
class: aClass package: anRPackage
	^ self new
		class: aClass;
		package: anRPackage;
		yourself! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:34'!
basename
	^ clazz isMeta
			ifTrue: [ 'class' ]
			ifFalse: [ 'instance' ]! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:44'!
class: aClass
	clazz := aClass! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:50'!
creationTime 
	^ DateAndTime now! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:43'!
fileEntriesDo: aBlock
	self methods do: aBlock! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:39'!
fileEntryAt: pathSegment ifAbsent: aBlock! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/11/2012 15:43'!
fileSize
	^ self methods size! !

!PackageClassExtensionOrganizer methodsFor: 'testing' stamp: 'CamilloBruni 7/3/2012 00:45'!
isDirectory
	^ true! !

!PackageClassExtensionOrganizer methodsFor: 'testing' stamp: 'CamilloBruni 7/16/2012 18:25'!
isFile
	^ self isDirectory not! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:50'!
methods
	^ package extensionMethodsForClass: clazz! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:50'!
modificationTime 
	^ DateAndTime now! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:43'!
package
	
	^ package! !

!PackageClassExtensionOrganizer methodsFor: 'accessing' stamp: 'CamilloBruni 7/3/2012 00:43'!
package: anObject
	
	package := anObject! !

!TraitBehavior methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:37'!
filEntryAt: pathSegment ifAbsent: absentBlock
	pathSegment = #class
		ifTrue: [ ^ self organization ].
	pathSegment = #instance
		ifTrue: [ ^ self  organization ].
	pathSegment = #'README.md'
		ifTrue: [ ^ ClassCommentEntry class: self  ].
	pathSegment = #resources
		ifTrue: [ ^ ResourcesEntry on: self ].
	^ absentBlock value.! !

!TraitBehavior methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/11/2012 15:31'!
fileEntriesDo: aBlock
	aBlock value: self organization.
	aBlock value: self class organization.
	aBlock value: (ClassCommentEntry class: self).
	aBlock value: (ResourcesEntry on: self)! !

!TraitBehavior methodsFor: '*FileSystem-Smalltalk' stamp: 'CamilloBruni 7/2/2012 23:54'!
isDirectory 
	^ true! !
